declare class RGB {
    r: number;
    g: number;
    b: number;
    constructor(r: number, g: number, b: number);
}
declare class HSL {
    h: number;
    s: number;
    l: number;
    constructor(h: number, s: number, l: number);
}
/**
 * Find, compute or return default value for the given name and maps of colors.
 * @param name the color name
 * @param defaultMap the default color map if no overriding in priority and fallback maps
 * @param fallbackMap the fallback map. The function will search in it if no color is found in priority map. Should be application config
 * @param priorityMap the priority map. If the color is found in it, the fallbackMap is not used. Should be customer config
 * @return The hex RBG color find or computed from all sources
 */
export declare function getColorFromMaps(name: string, defaultMap: any, fallbackMap: any, priorityMap: any): string;
export declare function convertLighten(rgbValue: RGB, lightModificator: number): string;
/**
 * Apply a -X to the color lightness.
 * @param color the color to darken. Must be hex color with #fff or #ffffff format
 * @param lightModificator the value of darken  operation. Default value to 10 if not set
 */
export declare function convertToDarkColor(color: string, lightModificator?: number): string;
export declare function hexToRgb(hex: any): RGB;
export declare function hexToRgbString(hex: any): string;
export declare function rgbToHsl(inputRGB: RGB): HSL;
export {};
